diff -Naur build/acconfig.h fam-2.6.8-freebsd-mntent/acconfig.h
--- build/acconfig.h	Mon Apr 29 16:26:53 2002
+++ fam-2.6.8-freebsd-mntent/acconfig.h	Mon Jul  8 17:01:14 2002
@@ -47,6 +47,8 @@
 **  Otherwise, we'll use MNTTYPE_NFS.  */
 #undef HAVE_FSID_NFS2
 
+#undef HAVE_MNTENT_H
+
 /* Define if we have MNTTYPE_NFS2 */
 #define HAVE_MNTTYPE_NFS2 0
 
diff -Naur build/config.h.in fam-2.6.8-freebsd-mntent/config.h.in
--- build/config.h.in	Mon Jun  3 12:08:52 2002
+++ fam-2.6.8-freebsd-mntent/config.h.in	Mon Jul  8 17:01:25 2002
@@ -12,6 +12,8 @@
 /*  Define if the system has imon and IMONIOC_ ioctl flags.  */
 #undef HAVE_IMON
 
+#undef HAVE_MNTENT_H
+
 /*  Define if the system has the struct revokdi and the IMONIOC_REVOKDI
 **  ioctl flag.  (IRIX 5.3 doesn't.)
 */
diff -Naur build/configure.in fam-2.6.8-freebsd-mntent/configure.in
--- build/configure.in	Mon Apr 29 17:55:42 2002
+++ fam-2.6.8-freebsd-mntent/configure.in	Mon Jul  8 17:01:30 2002
@@ -99,6 +99,8 @@
 dnl AC_HEADER_SYS_WAIT
 dnl AC_CHECK_HEADERS(fcntl.h limits.h sys/time.h syslog.h unistd.h)
 
+AC_CHECK_HEADER(mntent.h, AC_DEFINE(HAVE_MNTENT_H))
+
 dnl
 dnl  See if imon is available; if so, is it IRIX or Linux?
 dnl
@@ -314,10 +316,10 @@
 dnl If we don't have MNTTYPE_NFS , we croak.
 dnl
 
-FAM_DECL_IN_MNTENT(MNTTYPE_NFS, ,AC_MSG_ERROR(Didn't find MNTTYPE_NFS in mntent.h))
-FAM_DECL_IN_MNTENT(MNTTYPE_NFS2, AC_DEFINE(HAVE_MNTTYPE_NFS2))
-FAM_DECL_IN_MNTENT(MNTTYPE_NFS3, AC_DEFINE(HAVE_MNTTYPE_NFS3))
-FAM_DECL_IN_MNTENT(MNTTYPE_CACHEFS, AC_DEFINE(HAVE_MNTTYPE_CACHEFS))
+dnl FAM_DECL_IN_MNTENT(MNTTYPE_NFS, ,AC_MSG_ERROR(Didn't find MNTTYPE_NFS in mntent.h))
+dnl FAM_DECL_IN_MNTENT(MNTTYPE_NFS2, AC_DEFINE(HAVE_MNTTYPE_NFS2))
+dnl FAM_DECL_IN_MNTENT(MNTTYPE_NFS3, AC_DEFINE(HAVE_MNTTYPE_NFS3))
+dnl FAM_DECL_IN_MNTENT(MNTTYPE_CACHEFS, AC_DEFINE(HAVE_MNTTYPE_CACHEFS))
 
 dnl
 dnl  Test for bindresvport() prototype.
@@ -569,8 +571,6 @@
     man/fam.1m
     support/Makefile
     test/Makefile
-    util/Makefile
-    util/editconf/Makefile
 )
 
 dnl 
diff -Naur build/fam/FileSystem.c++ fam-2.6.8-freebsd-mntent/fam/FileSystem.c++
--- build/fam/FileSystem.c++	Mon Apr 29 16:26:54 2002
+++ fam-2.6.8-freebsd-mntent/fam/FileSystem.c++	Mon Jul  8 17:01:43 2002
@@ -22,7 +22,7 @@
 
 #include "FileSystem.h"
 
-#include <mntent.h>
+#include "mntent.h"
 #include <string.h>
 
 #include "Event.h"
diff -Naur build/fam/FileSystemTable.c++ fam-2.6.8-freebsd-mntent/fam/FileSystemTable.c++
--- build/fam/FileSystemTable.c++	Wed May 29 14:17:42 2002
+++ fam-2.6.8-freebsd-mntent/fam/FileSystemTable.c++	Mon Jul  8 17:01:53 2002
@@ -256,7 +256,10 @@
     //  create_fs_by_name initializes our "root" member variable.
     if (!fs_by_name)
     {   create_fs_by_name();
+#if !defined(__FreeBSD__)
+	/* there is no mtab "file" in freebsd! */
 	mtab_watcher = new InternalClient(mtab_name, mtab_event_handler, NULL);
+#endif
     }
 
     cr.become_user();
diff -Naur build/fam/Makefile.am fam-2.6.8-freebsd-mntent/fam/Makefile.am
--- build/fam/Makefile.am	Mon Apr 29 16:26:54 2002
+++ fam-2.6.8-freebsd-mntent/fam/Makefile.am	Mon Jul  8 17:02:42 2002
@@ -72,6 +72,7 @@
   main.c++ \
   timeval.c++ \
   timeval.h \
+  mntent_compat.c++ \
   @IMON_FUNCS@.c++
 
 EXTRA_fam_SOURCES = IMonIrix.c++ IMonLinux.c++ IMonNone.c++
diff -Naur build/fam/StringTable.h fam-2.6.8-freebsd-mntent/fam/StringTable.h
--- build/fam/StringTable.h	Mon Apr 29 16:26:54 2002
+++ fam-2.6.8-freebsd-mntent/fam/StringTable.h	Mon Jul  8 17:03:01 2002
@@ -25,6 +25,7 @@
 
 #include <assert.h>
 #include <string.h>
+#include "mntent.h"
 
 //  A StringTable maps C strings onto values.  It is a cheap O(n)
 //  implementation, suitable only for small tables that are
diff -Naur build/fam/mntent.h fam-2.6.8-freebsd-mntent/fam/mntent.h
--- build/fam/mntent.h	Thu Jan  1 10:00:00 1970
+++ fam-2.6.8-freebsd-mntent/fam/mntent.h	Mon Jul  8 17:00:25 2002
@@ -0,0 +1,56 @@
+/*
+ *  mntent
+ *  mntent.h - compatability header for FreeBSD
+ *
+ *  Copyright (c) 2001 David Rufino <daverufino@btinternet.com>
+ *  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#if defined(HAVE_MNTENT_H)
+#include <mntent.h>
+#else
+#ifndef _MNTENT_H
+#define _MNTENT_H
+#include <stdio.h>
+
+#define MOUNTED "dummy"
+
+#define MNTTYPE_NFS "nfs"
+
+struct mntent {
+	char *mnt_fsname;
+	char *mnt_dir;
+	char *mnt_type;
+	char *mnt_opts;
+	int mnt_freq;
+	int mnt_passno;
+};
+
+#define setmntent(x,y) ((FILE *)0x1)
+struct mntent *getmntent __P ((FILE *fp));
+char *hasmntopt __P ((const struct mntent *mnt, const char *option));
+#define endmntent(x) ((int)1)
+
+#endif /* _MNTENT_H */
+#endif /* HAVE_MNTENT_H */
diff -Naur build/fam/mntent_compat.c++ fam-2.6.8-freebsd-mntent/fam/mntent_compat.c++
--- build/fam/mntent_compat.c++	Thu Jan  1 10:00:00 1970
+++ fam-2.6.8-freebsd-mntent/fam/mntent_compat.c++	Mon Jul  8 17:00:44 2002
@@ -0,0 +1,151 @@
+/*
+ * Copyright (c) 1980, 1989, 1993, 1994
+ *      The Regents of the University of California.  All rights reserved.
+ * Copyright (c) 2001
+ *      David Rufino <daverufino@btinternet.com>
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by the University of
+ *      California, Berkeley and its contributors.
+ * 4. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+/* most of this was ripped from the mount(3) source */
+
+#include "config.h"
+#include "mntent.h"
+#if !defined(HAVE_MNTENT_H)
+#include <stdlib.h>
+#include <string.h>
+#include <sys/param.h>
+#include <sys/ucred.h>
+#include <sys/mount.h>
+
+static int pos = -1;
+static int mntsize = -1;
+static struct mntent _mntent;
+
+char *
+hasmntopt (const struct mntent *mnt, const char *option)
+{
+        int found;
+        char *opt, *optbuf;
+
+        optbuf = strdup(mnt->mnt_opts);
+        found = 0;
+        for (opt = optbuf; (opt = strtok(opt, " ")) != NULL; opt = NULL) {
+                if (!strcasecmp(opt, option)) {
+			opt = opt - optbuf + mnt->mnt_opts;
+			free (optbuf);
+			return (opt);
+		}
+        }
+	free (optbuf);
+        return (NULL);
+}
+
+static char *
+catopt (char *s0, const char *s1)
+{
+        size_t i;
+        char *cp;
+
+        if (s1 == NULL || *s1 == '\0')
+                return s0;
+        if (s0 && *s0) {
+                i = strlen(s0) + strlen(s1) + 1 + 1;
+                if ((cp = (char *)malloc(i)) == NULL)
+			return (NULL);
+                (void)snprintf(cp, i, "%s %s", s0, s1);
+        } else
+                cp = strdup(s1);
+
+        if (s0)
+                free(s0);
+        return (cp);
+}
+
+
+static char *
+flags2opts (int flags)
+{
+        char *res;
+        res = NULL;
+        res = catopt(res, (flags & MNT_RDONLY) ? "ro" : "rw");
+        if (flags & MNT_SYNCHRONOUS)    res = catopt(res, "sync");
+        if (flags & MNT_NOEXEC)         res = catopt(res, "noexec");
+        if (flags & MNT_NOSUID)         res = catopt(res, "nosuid");
+        if (flags & MNT_NODEV)          res = catopt(res, "nodev");
+        if (flags & MNT_UNION)          res = catopt(res, "union");
+        if (flags & MNT_ASYNC)          res = catopt(res, "async");
+        if (flags & MNT_NOATIME)        res = catopt(res, "noatime");
+        if (flags & MNT_NOCLUSTERR)     res = catopt(res, "noclusterr");
+        if (flags & MNT_NOCLUSTERW)     res = catopt(res, "noclusterw");
+        if (flags & MNT_NOSYMFOLLOW)    res = catopt(res, "nosymfollow");
+        if (flags & MNT_SUIDDIR)        res = catopt(res, "suiddir");
+
+        return res;
+}
+
+static struct mntent *
+statfs_to_mntent (struct statfs *mntbuf)
+{
+	static char opts_buf[40], *tmp;
+	
+	_mntent.mnt_fsname = mntbuf->f_mntfromname;
+	_mntent.mnt_dir = mntbuf->f_mntonname;
+	_mntent.mnt_type = mntbuf->f_fstypename;
+	tmp = flags2opts (mntbuf->f_flags);
+	if (tmp) {
+		opts_buf[sizeof(opts_buf)-1] = '\0';
+		strncpy (opts_buf, tmp, sizeof(opts_buf)-1);
+		free (tmp);
+	} else {
+		*opts_buf = '\0';
+	}
+	_mntent.mnt_opts = opts_buf;	
+	_mntent.mnt_freq = _mntent.mnt_passno = 0;
+	return (&_mntent);
+}
+
+struct mntent *
+getmntent (FILE *fp)
+{
+	struct statfs *mntbuf;
+
+	if (pos == -1 || mntsize == -1)
+		mntsize = getmntinfo (&mntbuf, MNT_NOWAIT);
+
+	++pos;
+	if (pos == mntsize) {
+		pos = mntsize = -1;
+		return (NULL);
+	}
+
+	return (statfs_to_mntent (&mntbuf[pos]));
+}
+
+#endif /* HAVE_MNTENT_H */
